<?php 
  
/*
------------------------------------------------
AlphaCMS - универсальный движок для вашего сайта
E-mail администрации проекта: adm@alpha-cms.ru
Официальный сайт поддержки: alpha-cms.ru
Руководитель проекта: adm (ID 1)
------------------------------------------------
*/
  
FOREACH (ARRAY('config', 'connect', 'users') AS $connect) {
  
  INCLUDE_ONCE ("../../system/connections/global/$connect.php"); 
  
}

ACCESS('users');

IF (ISSET($_FILES['file']) && AJAX() == TRUE){
  
  IF (GET('dir') > 0){
    
    $dir = DB::GET_STRING("SELECT * FROM `PHOTOS_DIR` WHERE `ID` = '".INTVAL(GET('dir'))."' AND `USER_ID` = '".$user['ID']."' LIMIT 1");
    
    $id = $dir['ID'];
    $private = $dir['PRIVATE'];
    
  }ELSE{
    
    $id = 0;
    $private = 0;
  
  }
  
  //Максимальный размер для выгрузки
  $MaxFileSize = CONFIG('MAXFILESIZE');
  
  //Разрешенные форматы для выгрузки
  $AllowFileExtension = ARRAY('jpg', 'jpeg', 'png', 'gif');
  
  //Оригинальное название изображения
  $FileNameExp = $_FILES['file']['name'];
  
  //Оригинальное название изображения без расширения
  $FileName = TEXT_PROCESSING(PREG_REPLACE('#\.[^\.]*$#', NULL, $FileNameExp));
  
  //Расширение изображения
  $Exp = STRTOLOWER(PREG_REPLACE('#^.*\.#', NULL, $FileNameExp));
  
  //Временный файл
  $TempName = $_FILES['file']['tmp_name'];
  
  //Папка куда будут загружаться изображения
  $UploadDir = ROOT."/files/upload/photos/source/";
  
  //Проверка расширения изображения
  $FileExtension = PATHINFO(STRTOLOWER($FileNameExp), PATHINFO_EXTENSION);
  
  //Принудительно устанавливаем права 777 на папку
  @CHMOD($UploadDir, 0777);
  
  //Определяем ширину и высоту изображения
  $xy = GETIMAGESIZE($TempName);  
  $width = $xy[0]; 
  $height = $xy[1];  
  
  $err_data = 0;
  
  //Настройки фотоальбомов
  $photos_settings = @PARSE_INI_FILE(ROOT."/system/config/photos.ini", FALSE);
  
  IF (DB::GET_COLUMN("SELECT COUNT(*) FROM `PHOTOS` WHERE `USER_ID` = '".$user['ID']."'") >= $photos_settings['PHOTOS_LIMIT']){

    $error = "Вы исчерпали лимит на добавление фото";
    $err_data = 1;
    
  }

  IF (DB::GET_COLUMN("SELECT COUNT(*) FROM `PHOTOS` WHERE `USER_ID` = '".$user['ID']."' AND `NAME` = '".$FileName."' AND `ID_DIR` = '".$id."' LIMIT 1") == 1){

    $error = "Фото с таким названием уже есть в этом альбоме";
    $err_data = 1;
    
  }
  
  IF (ISSET($dir) && !$dir['ID'] && GET('dir') > 0){

    $error = "Директории не существует";
    $err_data = 1;
  
  }
  
  IF (CONFIG('FILE_ACCESS') == 0) {
    
    $error = "Выгрузка файлов на сайте приостановлена администрацией";
    $err_data = 1;
  
  }
  
  IF ($xy == FALSE) {
    
    $error = "Не удалось получить содержимое изображения";
    $err_data = 1;
  
  }
  
  IF ($width < 150) {
    
    $error = "Ширина изображения не может быть меньше 150px. Текущая ширина: ".$width."px";
    $err_data = 1;
  
  }
  
  IF ($height < 150) {
    
    $error = "Высота изображения не может быть меньше 150px. Текущая высота: ".$height."px";
    $err_data = 1;
  
  }
  
  IF (!IN_ARRAY($FileExtension, $AllowFileExtension)) {
    
    $error = "Неверный формат изображения";
    $err_data = 1;
  
  }
  
  //Проверка размера изображения
  IF (FILESIZE($TempName) > $MaxFileSize) {
    
    $error = "Размер загружаемого изображения превышает установленные ограничения";
    $err_data = 1;
  
  }
  
  IF (STR($FileName) < 1) {
    
    $error = "Имя загружаемого изображения не должно быть менее 1 символа";
    $err_data = 1;
  
  }

  IF (STR($FileName) > 200) {
    
    $error = "Имя загружаемого изображения не должно быть более 200 символов";
    $err_data = 1;
  
  }
  
  IF ($err_data == 1){
    
    ECHO "<div class='file-upload-progress' style='color: red;'><i class='fa fa-exclamation-triangle fa-fw'></i> ".LG($error)."</div>";
  
  }ELSE{
    
    $ID = DB::GET_ADD("INSERT INTO `PHOTOS` (`NAME`, `USER_ID`, `EXT`, `SIZE`, `TIME`, `ID_DIR`) VALUES ('".$FileName."', '".$user['ID']."', '".$Exp."', '".FILESIZE($TempName)."', '".TIME()."', '".$id."')");
    
    //Начисление баллов
    BALLS_ADD('PHOTOS');
    
    //Начисление рейтинга
    RATING_ADD('PHOTOS');
    
    //Сохраняем изображение если все хорошо
    $CopyFile = COPY($TempName, "".$UploadDir."".$ID.".".$Exp."");
    
    IF (!$CopyFile) {
      
      ECHO "<div class='file-upload-progress' style='color: red;'><i class='fa fa-exclamation-triangle fa-fw'></i> ".LG('Неизвестная ошибка')."</div>";
    
    }ELSE{
      
      CROP_IMAGE(ROOT.'/files/upload/photos/source/'.$ID.'.'.$Exp.'', ROOT.'/files/upload/photos/50x50/'.$ID.'.jpg', 50, 50);
      CROP_IMAGE(ROOT.'/files/upload/photos/source/'.$ID.'.'.$Exp.'', ROOT.'/files/upload/photos/150x150/'.$ID.'.jpg', 150, 150);
      CROP_IMAGE(ROOT.'/files/upload/photos/source/'.$ID.'.'.$Exp.'', ROOT.'/files/upload/photos/240x240/'.$ID.'.jpg', 240, 240);
      CROP_IMAGE(ROOT.'/files/upload/photos/source/'.$ID.'.'.$Exp.'', ROOT.'/files/upload/photos/260x600/'.$ID.'.jpg', 600, 260);
      
      /*
      ------------------------------
      Отправляем подписчикам в ленту
      ------------------------------
      */
      
      IF ($private == 0){
        
        $data = DB::GET_STRING_ALL("SELECT * FROM `SUBSCRIBERS` WHERE `USER_ID` = '".$user['ID']."'");
        
        WHILE ($list = $data->FETCH()){
          
          DB::GET_ADD("INSERT INTO `TAPE` (`USER_ID`, `OBJECT_ID`, `OBJECT_ID_LIST`, `TIME`, `TYPE`) VALUES ('".$list['MY_ID']."', '".$ID."', '".$list['USER_ID']."', '".TIME()."', 'user_photo')");
        
        } 
        
      }
      
      /*--------------------------*/
      
      //Отправляем запрос на обновление заставки если успешно
      ?>
      <script>  
        
      var data = "/modules/?path=photos&section=users&id=<?=$user['ID']?>&dir=<?=$id?>";
      var toLoad = data+' #photo_upgrade';
      
      open_modal = 0;
      
      $("#photo_upgrade").load(toLoad); 
      
      $("#add_photo").removeClass("open");
      
      setTimeout( function(){	
        
        $("#add_photo").parents(".overlay").removeClass("open");
      
      }, 5);
      
      $('#upload-photo-show').html('');
      
      </script>  
      <?
    
    }
  
  }
  
}ELSE{
  
  REDIRECT('/index');

}
 
?>